<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: applet/CrudApplet.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: applet/CrudApplet.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * Created by jasonlin on 6/20/14.
 */
define(['underscore', 'jquery', 'uweaver/lang',
    'uweaver/applet/Applet', 'uweaver/widget/TabPanel', 'uweaver/widget/Finder2', 'uweaver/widget/Viewer',
    'text!./tpl/CrudApplet.html',
    'uweaver/validator',
    'uweaver/Logger'], function (_, $, lang, Applet, TabPanel, Finder, Viewer, tpl, validator, Logger) {

    var declare = lang.declare;
    var prompt = uweaver.prompt;

    var Base = Applet;

    var CrudApplet = declare(Base, {
        /**
         * constructors
         */
        initialize: initialize,

        /**
         * public interfaces
         */
        browse: browse,
        add: add,
        edit: edit,
        save: save,
        erase: erase,

        /**
         * protected members
         */
        logger: new Logger("CrudApplet"),
        prepare: prepare,
        store: undefined,
        tplFinder: undefined,
        tplViewer: undefined,

        /**
         * private members
         */
        _tabPanel: undefined,
        _finder: undefined,
        _viewers: {},


        /**
         * event handler
         */
        onTabsActivate: function(event) {
            if(event.data.newTab==="finder") {
                this.finder.refresh();
            }
        },

        onFinderEdit: function(event) {
            if(event.data.length===0) {
                prompt.info("Please select one item.");
                return false;
            }
            this.edit(event.data);
        },

        onFinderAdd: function(event) {
            this.add();
        },

        onFinderDelete: function(event) {
            if(event.data.length===0) {
                prompt.info("Please select one record.");
                return false;
            }
            prompt.confirm("Delete?", {
                yes: function() {
                    var finder = event.context;
                    this.erase(finder);
                }
            });
            var finder = event.context;
            this.erase(finder);
        },

        onViewerSave: function(event) {
            var viewer = event.context;
            this.save(viewer);
        },

        onViewerClose: function(event) {
            var viewer = event.context;
            var name = viewer.name();
            this.viewers[name] = undefined;
            this.tabPanel.remove(name);
            viewer.destroy();
            this.browse();
        }
    });

    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);

        this.tpl = tpl;
    }

    function prepare() {
        Base.prototype.prepare.apply(this, arguments);

        var $tabPanel = this.$("[data-role=tabs]");
        var tabPanel = new TabPanel({
            el: $tabPanel
        });

        tabPanel.render({enhance: false});
        tabPanel.on("activate", _.bind(this.onTabsActivate, this));

        this._tabPanel = tabPanel;

        var $finder = tabPanel.$panel("finder");

        var finder = new Finder({
            el: $finder,
            tpl: this.tplFinder,
            store: this.store
        });
        finder.render();
        finder.on('edit', _.bind(this.onFinderEdit, this));
        finder.on('add', _.bind(this.onFinderAdd, this));
        finder.on('delete', _.bind(this.onFinderDelete, this));

        this._finder = finder;
    }

    function browse() {
        this._finder.refresh();
        this._tabPanel.active("finder");
    }

    function edit(items) {
        var model = _.first(items);
        model.fetch().then(function(args) {
            var viewer = new Viewer({
                tpl: this.tplViewer,
                model: model,
                mode: "edit"
            });
            viewer.render();
            viewer.on('save', _.bind(this.onViewerSave, this));
            viewer.on('close', _.bind(this.onViewerClose, this));
            var name = this._tabPanel.add("viewer", viewer.$el, {
                title: "Edit",
                icon: "edit"
            });
            viewer.name(name);
            this._viewers[name] = viewer;
            this._tabPanel.active(name);
        }, function(response){
            prompt.warn("Data not found!", {
                explanation: response.responseText
            });
        }, this);

    }

    function add() {
        var model = new this.store.model();
        var viewer = new Viewer({
            tpl: this.tplViewer,
            model: model,
            mode: "create"
        });
        viewer.render();
        viewer.on('save', _.bind(this.onViewerSave, this));
        viewer.on('close', _.bind(this.onViewerClose, this));
        var name = this._tabPanel.add("viewer", viewer.$el, {
            title: "Create",
            icon: "plus"
        });
        viewer.name(name);
        this._viewers[name] = viewer;
        this._tabPanel.active(name);
    }

    function erase(finder) {

        var items = finder.selection();
        var model = _.first(items);

        var promise = model.destroy({wait: true});
        promise.then(function() {
            finder.refresh();
        }, function() {
            prompt.warn("Failed to delete the record!");
        }, this);
    }


    function save(viewer) {
        var values = viewer.values();

        viewer.disable();

        if(!viewer.model.set(values, {validate: true})) {
            var violations = viewer.model.validationError;
            violations = validator.translate(violations, viewer.labels);
            prompt.warn(validator.compose(violations));
            viewer.enable();
            return;
        }

        var promise = viewer.model.save();

        promise.then(function() {
            viewer.mode('edit');
            viewer.enable();
        }, function() {
            prompt.warn("Failed to create the record!");
            viewer.enable();
        });

        return;
    }

    return CrudApplet;
});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
